<?php

/**
 * @package Stupid Bouncy BBC
 *
 * @author: antechinus
 * @copyright (c) 2020 Antechinus
 * @license: ISC - https://opensource.org/licenses/IS/
 *
 * @Version 1.0
 */

if (!defined('ELK'))
	die('No access...');

/**
 *	stupid_bouncy
 *
 * Subs hook for 1.0.x & 1.1.x, integrate_bbc_codes hook, Called from Subs.php
 * Used to add [bouncy][/bouncy] parsing values
 *
 * @param mixed[] $codes array of codes as defined for parse_bbc
 */

function stupid_css()
{
	global $modSettings;

	// Do some css magics
	if (!empty($modSettings['disabledBBC']))
	{
		foreach (explode(',', $modSettings['disabledBBC']) as $tag)
		{
			if ($tag === 'bounce')
				return;
		}
	}

	loadCSSFile('stupid_bouncy.css');
}

function stupid_bouncy(&$codes)
{
	global $modSettings;

	// Only for when bbc is on.
	if (empty($modSettings['enableBBC']))
		return;

	// Make sure the admin has not disabled the bouncy tag.
	if (!empty($modSettings['disabledBBC']))
	{
		foreach (explode(',', $modSettings['disabledBBC']) as $tag)
		{
			if ($tag === 'bouncy')
				return;
		}
	}

	// Now to wreak havoc n unsuspecting web denizens!
	$codes[] = array(
		'tag' => 'bouncy',
		'before' => '<div class="parrot_cage"><div class="parrotz">',
		'after' => '</div></div>',
		'block_level' => true,
		'disallow_children' => array('move, quote, code, hr'),
	);
}

/**
 *	stupid_bouncy
 *
 * Codes hook for 1.1.x, integrate_additional_bbc, Called from ParseWrapper getCodes()
 *
 * @param mixed[] $codes array of codes as defined for parse_bbc
 */
function stupid_bounces(&$codes)
{
	// Add our tag info to the parser, this controls how the tag will render
	$codes[] =
		array(
			\BBC\Codes::ATTR_TAG => 'bouncy',
			\BBC\Codes::ATTR_TYPE => \BBC\Codes::TYPE_PARSED_CONTENT,
			\BBC\Codes::ATTR_BEFORE => '<div class="parrot_cage"><div class="parrotz">',
			\BBC\Codes::ATTR_AFTER => '</div></div>',
			\BBC\Codes::ATTR_DISALLOW_CHILDREN => array('move, quote, code, hr'),
			\BBC\Codes::ATTR_BLOCK_LEVEL => true,
			\BBC\Codes::ATTR_AUTOLINK => false,
			\BBC\Codes::ATTR_LENGTH => 6,
		);
}